--- old/usr/src/cmd/svc/startd/graph.c	Mon Oct 15 13:25:12 2018
+++ new/usr/src/cmd/svc/startd/graph.c	Mon Oct 15 13:25:12 2018
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2018 Joyent, Inc.
  * Copyright (c) 2015, Syneto S.R.L. All rights reserved.
  * Copyright 2016 Toomas Soome <tsoome@me.com>
  * Copyright 2016 RackTop Systems.
@@ -576,7 +577,7 @@
 typedef int (*graph_walk_cb_t)(graph_vertex_t *, void *);
 
 typedef struct graph_walk_info {
-	graph_walk_dir_t 	gi_dir;
+	graph_walk_dir_t	gi_dir;
 	uchar_t			*gi_visited;	/* vertex bitmap */
 	int			(*gi_pre)(graph_vertex_t *, void *);
 	void			(*gi_post)(graph_vertex_t *, void *);
@@ -3849,6 +3850,8 @@
 static void *
 sulogin_thread(void *unused)
 {
+	(void) pthread_setname_np(pthread_self(), "sulogin");
+
 	MUTEX_LOCK(&dgraph_lock);
 
 	assert(sulogin_thread_running);
@@ -3876,6 +3879,8 @@
 	char *buf;
 	int r;
 
+	(void) pthread_setname_np(pthread_self(), "single_user");
+
 	MUTEX_LOCK(&single_user_thread_lock);
 	single_user_thread_count++;
 
@@ -5779,6 +5784,8 @@
 	scf_handle_t *h;
 	int err;
 
+	(void) pthread_setname_np(pthread_self(), "graph_event");
+
 	h = libscf_handle_create_bound_loop();
 
 	/*CONSTCOND*/
@@ -6138,6 +6145,8 @@
 	scf_handle_t *h;
 	int err;
 
+	(void) pthread_setname_np(pthread_self(), "graph");
+
 	h = libscf_handle_create_bound_loop();
 
 	if (st->st_initial)
@@ -6794,6 +6803,8 @@
 	char *pg_name = startd_alloc(max_scf_value_size);
 	int r;
 
+	(void) pthread_setname_np(pthread_self(), "repository_event");
+
 	h = libscf_handle_create_bound_loop();
 
 	pg = safe_scf_pg_create(h);
